#!/usr/bin/env python
#-*- coding: utf-8 -*-

import os, sys, types
from pyparsing import *

def printResult(t, res):
	print 'Parse ==> ', t
	print 'Result:'
	for r in res:
		print ' '*3, r
	print '='*40

def convInt(s, loc, toks):
	#print 'S    = ', s
	#print 'LOC  = ', loc
	#print 'TOKS = ', toks
	return int(toks[0])

def convFloat(s, loc, toks):
	return float(toks[0])

def setCommand(s, loc, toks):
	#return ['COMMAND', toks[0]]
	return toks

def makeLogoParser():
	Logo = Forward()
	words = Word(alphanums+'!§$%/()=?\_.:,;#@~*^°<>-äüöÄÜÖß')
	wordsall = Word(alphanums+'!§$%&/()=?\_.:,;#@~*^°<>-äüöÄÜÖß')
	KOMMA = Suppress(',')
	Punkt = Literal('.')
	PLUS = Literal('+')
	MINUS = Literal('-')
	
	LINKS  = CaselessKeyword('links')
	RECHTS = CaselessKeyword('rechts')
	VOR    = CaselessKeyword('vor')
	ZURUCK = CaselessKeyword('zuruck')
	GEHEZU = CaselessKeyword('gehezu')
	COMMANDS = LINKS | RECHTS | VOR | ZURUCK | GEHEZU
	
	FOR    = CaselessKeyword('for')
	ENDFOR = CaselessKeyword('endfor')
	
	INT = Word(nums)
	INTEGER = Combine(Optional(MINUS|PLUS) + INT).setParseAction(convInt)
	
	VARNAME	= Word(alphas+'_',alphanums+'_')
	GLEICH = Literal('=')
	
	VALUE = INTEGER | VARNAME
	EXPR = Forward()
	EXPR << (operatorPrecedence(VALUE, [
			(oneOf('! -'), 2, opAssoc.RIGHT),
			(oneOf('* / %'), 2, opAssoc.LEFT),
			(oneOf('+ -'), 2, opAssoc.LEFT),
			]))
	FUNCTION = Group(COMMANDS + Optional(Group(delimitedList(EXPR))))
	DECL = Group(VARNAME + GLEICH + FUNCTION)
	
	FORSTMNT = Forward()
	FORSTMNT = Group(FOR + VARNAME + GLEICH + delimitedList(EXPR) + Group(ZeroOrMore(FUNCTION | FORSTMNT)) + ENDFOR)
	
	Logo = OneOrMore(FUNCTION | DECL | FORSTMNT)
	
	return Logo

def testLogo():
	def execExpr(expr):
		#print expr
		if type(expr) == types.IntType:
			return expr
		elif type(expr) in types.StringTypes:
			return var[expr]
		else:
			if len(expr) > 3:
				i = execExpr([expr[0], expr[1], expr[2:]])
			else:
				i = execExpr(expr[0])
				if expr[1] == '+':
					i += execExpr(expr[2])
				elif expr[1] == '-':
					i -= execExpr(expr[2])
				elif expr[1] == '*':
					i *= execExpr(expr[2])
				elif expr[1] == '/':
					i /= execExpr(expr[2])
			
			return i
	
	def printCommand(commands, level=0):
		for com in commands:
			#print com
			#continue
			if com[0] == 'gehezu':
				print ' '*level + 'COMMAND <%s> Parameter: %i, %i'%(com[0], execExpr(com[1][0]), execExpr(com[1][1]))
			elif com[0] in ['rechts', 'links', 'vor', 'zuruck']:
				print ' '*level + 'COMMAND <%s> Parameter: %i'%(com[0], execExpr(com[1][0]))
			
			if com[0] == 'for':
				var[com[1]] =  0
				start = execExpr(com[3])
				end   = execExpr(com[4])
				if len(com) == 8:
					step = com[5]
					body = com[6]
				else:
					step = 1
					body = com[5]
				
				for i in range(start, end, step):
					var[com[1]] =  i
					#print ' '*level + 'FOR:  %s von %s bis %s mit Schrittweite %s'%(com[1], str(com[3]), str(com[4]), step)
					printCommand(body, level+1)
					#print ' '*level + 'ENDFOR'
	
	t = """gehezu 100,100
	rechts 90
	vor 100
	rechts 90
	vor 100
	rechts 90
	VOR 100
	rechts 90
	vor 100
	for i=0,360,30
		vor i/10+(3*i/10)
		rechts i
	endfor
	"""
	lines = t.split('\n')
	iniData = chr(10).join(lines)
	
	logo = makeLogoParser()
	
	res = logo.parseString(t)
	printResult(t, res)
	print
	print 'RES = ', res
	
	var = {}
	printCommand(res)

if __name__ == "__main__":
	testLogo()
